Subject: Ειδοποίηση του χρήστη όταν κάτι είναι σε εξέλιξη στο UI

Description

Κάθε φορά που το UI κάνει POST ή PUT, πρέπει να φαίνεται ότι κάτι είναι σε εξέλιξη.

Αν κανείς δοκιμάσει με αργό δίκτυο αυτό είναι πολύ εμφανές, τα πάντα φαίνονται κολλημένα.

Ενδεικτικά σημεία:

1. add metadata / delete metadata

2. create VM

Στο 2 ειδικά, εξαφανίζεται ο wizard, περνάνε από 2 έως 22 δευτερόλεπτα, και μετά βγαίνει το παράθυρο ότι κάτι συνέβη.

Ενδεικτική υλοποίηση: το "create VM" αντικαθίσταται από μικρό γραφικό [τύπου 

http://customregistries.com/wp-content/plugins/wptouch/images/progress.gif] που δείχνει ότι το POST είναι σε εξέλιξη. Όταν

επιστρέψει, εξαφανίζεται ο wizard και βγαίνει κανονικά είτε το παράθυρο επιτυχίας, είτε το αποτυχίας.

Ομοίως με κουμπιά Add/delete κλπ στα metadata.

Τα παραπάνω είναι ενδεικτικά, η συγκεκριμένη σχεδιαστική λογική είναι πάγια ανάγκη για κάθε κουμπί που κάνει κάποια ενέργεια.

Related issues:

related to Synnefo - Feature # 469: Επέκταση του UI ώστε να κάνει κλήσεις στο... Closed 05/07/2011

Associated revisions

Revision da4f0310 - 05/21/2011 09:07 pm - Markos Gogoulos 

user notification when machine is created

show a progress icon when a machine is created.

when machine is ready (or in error cases) show back the Create new message

Refs #471

Revision 0d911a47 - 05/22/2011 06:52 pm - Markos Gogoulos 

user notification when machine is created

show a progress icon when a machine is created and keep the wizard on.

when machine is ready (or in error cases) hide the icon and the wizard

Refs #471

Revision a4685348 - 05/27/2011 01:57 pm - Mike Muzurakis

fix spinner on metadata overlay, Refs #471
Revision afedad4d - 06/30/2011 06:44 pm - Markos Gogoulos 

add check for windows OS.

Refs #471

History

#1 - 05/13/2011 11:12 am - Vangelis Koukis

- Target version set to v0.4

#2 - 05/14/2011 03:21 pm - Christos Psaltis

- Status changed from New to Assigned

- Assignee changed from Dimitris Moraitis to Christos Psaltis

#3 - 05/14/2011 04:13 pm - Markos Gogoulos

- Assignee changed from Christos Psaltis to Markos Gogoulos

#4 - 05/21/2011 09:13 pm - Markos Gogoulos

Το 2) έγινε, εμφανίζεται το progress icon στη θέση του 'Create new' και μόλις ολοκληρωθεί (success ή error) εμφανίζει πάλι το κείμενο.

#5 - 05/22/2011 04:42 am - Vangelis Koukis

Markos Gogoulos wrote:

Το 2) έγινε, εμφανίζεται το progress icon στη θέση του 'Create new' και μόλις ολοκληρωθεί (success ή error) εμφανίζει πάλι το κείμενο.

Όχι, το θέμα είναι το progress icon να βγαίνει πάνω στο κουμπί που πατάει ο χρήστης όταν ζητήσει να γίνει κάτι. Από την περιγραφή του ticket:

"το "create VM" αντικαθίσταται από μικρό γραφικό [τύπου http://customregistries.com/wp-content/plugins/wptouch/images/progress.gif] που δείχνει ότι

το POST είναι σε εξέλιξη. Όταν επιστρέψει, εξαφανίζεται ο wizard και βγαίνει κανονικά είτε το παράθυρο επιτυχίας, είτε το αποτυχίας.".

Δεν έχει πολύ νόημα να αντικαθίσταται ένα άλλο κουμπί από αυτό που πάτησε. Το progress icon πρέπει να βγαίνει στο τελευταίο κουμπί του Wizard,

κάτω δεξιά, "Create VM". Ο Wizard μένει στην οθόνη, το "create vm" έχει γίνει progress icon, και όταν έρθει η απάντηση από το POST [ο χρήστης

βλέπει το εικονίδιο να παίζει, ξέρει ότι κάτι περιμένει να γίνει", τότε ο wizard εξαφανίζεται και είτε είναι όλα ΟΚ, βλέπει το νέο του μηχάνημα, είτε

κάτι πήγε στραβά, βλέπει το παράθυρο με το λάθος.

Ομοίως και με οποιοδήποτε άλλο κουμπί κάνει POST. Όταν πατάω το κουμπί που προκαλεί το POST, αυτό αντικαθίσταται από το progress icon.

#6 - 05/22/2011 02:45 pm - Christos Psaltis

Αυτό που υλοποίησε ο Μάρκος ήταν διαφορετικό από αυτό που πρότεινες στο ticket, για να μην φαίνεται το ui unresponsive στην περίπτωση που τα

calls αργούν πολύ. Αφού δεν σας φαίνεται καλό έτσι θα το κάνουμε όπως ακριβώς λες.

#7 - 05/22/2011 05:23 pm - Vangelis Koukis

Ναι δε διαφωνώ ότι ο σκοπός είναι να μην φαίνεται unresponsive. Απλώς έχω την εντύπωση ότι είναι πιο ξεκάθαρο στο χρήστη τι ακριβώς είναι αυτό

που περιμένει, αν το progress icon βγαίνει πάνω στην ενέργεια για την οποία περιμένει. Αφού για τη δημιουργία του VM περιμένει να πάρει απάντηση
"ΟΚ, ξεκίνησα να το φτιάχνω", ή "Όχι, δεν μπορώ να ξεκινήσω να το φτιάχνω", όταν πατάει το τελευταίο κουμπί "Create VM" του Wizard, είναι λογικό

το κουμπι "Create VM" του wizard να αποκτά το progress icon, κι ο wizard να μη φεύγει, μέχρι να υπάρξει απάντηση στην κλήση POST /servers που

γίνεται από πίσω [ή timeout, κι αυτό απάντηση είναι, πρέπει να βγει το error box].

#8 - 05/22/2011 06:56 pm - Markos Gogoulos

Στο 721eb70..23a1975 μπήκε το progress icon στη θέση που προτείνεις και ο wizard μένει ανοικτός μέχρι να πάρει success ή error.

#9 - 05/26/2011 07:44 pm - Christos Psaltis

- % Done changed from 0 to 90

#10 - 05/27/2011 02:02 pm - Mike Muzurakis

- Status changed from Assigned to Feedback

Οκ, μπήκε και στο metadata wizard. Πρέπει να υπάρχει όπου χρειάζεται τώρα.

#11 - 05/31/2011 07:54 pm - Vangelis Koukis

- Status changed from Feedback to Assigned

Τουλάχιστον στο παράθυρο για create new network βγαίνει σωστά η ειδοποίηση, αλλά αν υπάρξει σφάλμα, το παράθυρο μένει για πάντα εκεί.

Οπουδήποτε υπάρχει κουμπί "ok" / "finish" κλπ, η ιδέα είναι ότι το παράθυρο μένει ανοιχτό, το κουμπί αντικαθίσταται με spinner, μέχρι που να έρθει η

απάντηση, οπότε το παράθυρο εξαφανίζεται και αν έχει συμβεί σφάλμα εμφανίζεται η ειδοποίηση σφάλματος.

#12 - 06/01/2011 10:08 am - Mike Muzurakis

- Status changed from Assigned to Feedback

Οκ, έγινε κι αυτό στο commit:f24cdced

#13 - 06/01/2011 11:22 am - Vangelis Koukis

- Status changed from Feedback to Closed

Το κλείνω, φαίνεται να δουλεύει σωστά.

04/24/2024 3/3


